import tomlkit

def readPipFile():
	with open('./Pipfile', 'r') as fID:
		tomlStr = fID.read()

	return tomlkit.parse(tomlStr)


def generateRequiresString(packageName, version):
	if not type(version) == tomlkit.items.String:
		raise ValueError(
			f'cannot parse version number for package "{packageName}". Is it installed as an editable package?'
		)
	else:
		if version == '*':
			version = ''

	return packageName + version


def getInstallRequires():
	install_requires = []
	pipfileDoc = readPipFile()
	packages = pipfileDoc['packages']
	for packageName in packages:
		install_requires.append(
			generateRequiresString(packageName, packages[packageName])
		)

	return install_requires


def writeInstallRequiresPythonFile(install_requires):
	fileStr = '# this file is autogenerated. Do not edit.'
	fileStr += '\n\n'
	fileStr += 'install_requires = [\n'
	for requirement in install_requires:
		fileStr += '  \'' + requirement + '\'' + '\n'
	fileStr += ']\n'

	with open('./install_requires.py', 'w') as fID:
		fID.write(fileStr)


def pipfile2installRequires():
	install_requires = getInstallRequires()
	writeInstallRequiresPythonFile(install_requires)
